/*
Copyright (C) 2003-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef RGPROCESS_H
#define RGPROCESS_H

/*
 * rgLocalSemaphor
 * Description: rgLocalSemaphor is used to block functions of the same
 * 	process. rgLocalSemaphor does not work for functions in seperate
 *	processes or threads. The blocking is achived because each time an
 *	instance of rgLocalSemaphor is created, it is pointed to a shared
 *	memory location. Only one instance of rgLocalSemaphor can obtain a
 *	lock for a shared memory location.
 */
class rgLocalSemaphor
{
public:
	rgLocalSemaphor( bool *p_lock_addr);
	~rgLocalSemaphor();

	bool lock();
private:
	bool *lock_addr;
	rgLocalSemaphor *owner;
};

#endif
